/****************************************************************/
/*								*/
/* Channel ; stellt Kanal fr RIG HRPT RX			*/
/* PIC-Controller ein					*/
/*								*/
/****************************************************************/

#include <stdio.h>
#include <dos.h>
#include <alloc.h>
#include <time.h>

#define RBR 0x00	/* Empfangsregister		*/
#define DLL 0x00	/* Baudrate (LS) DLAB = 1	*/
#define IER 0x01	/* Interrupt enable DLAB = 0	*/
#define DLM 0x01	/* Baudrate (MS) DLAB = 1	*/
#define LCR 0x03	/* Leitungskontrollregister	*/
#define MCR 0x04	/* Modemkontrollregister	*/
#define LSR 0x05	/* Linestatusregister		*/
#define baudpar 0x03    /* 8 bit,no parity,1 stop	*/
#define bitrate 19200

/* fr serielles I/O*/
int divisor=115200/bitrate,comp,com=0;
int comarr[4] = { 0x03f8,0x02f8,0x03e8,0x02e8 };

void serinit()
{
comp = comarr[com]; 		/* port number 0=com1 */
/* outportb((comp+IER), 0x00);	/* disable interrupts */
outportb((comp+LCR), 0x80);	/* DLAB=1*/
outportb((comp+DLL), (unsigned char) (divisor & 0x00ff)); /*low byte*/
outportb((comp+DLM), (unsigned char) (divisor & 0xff00) >> 8 );/*high byte*/
outportb((comp+LCR), baudpar);
outportb((comp+MCR), 0x03);	/*DTR,RTS*/
delay(10);
}

void lcddrv(prefix,x,laenge)
char *x,*prefix;
{
int n;

	while ( (inportb(comp+LSR) < 0x20) ) ;
	outportb((comp+RBR), prefix[0]);
	while ( (inportb(comp+LSR) < 0x20) ) ;
	outportb((comp+RBR), prefix[1]);
	for (n = 0; n < laenge; n++)
	{
	while ( (inportb(comp+LSR) < 0x20) ) ;
	outportb( (comp+RBR), x[n] );
	}
}


/* Hauptprogramm */
void main()
{
int status;
int chan=0;
char stringser[16];
time_t t;

time(&t);
printf("\ntoday is: %s\n", ctime(&t));

if ( _argc <=1 ) printf("run with: Channel <channel> <com>\n");


com=0;
if ( _argc > 2 ) com=abs(atoi( _argv[2]))-1;

while ( (com < 0) | (com > 3) )
	{
	printf ( "wrong COM-Port Number (1-4)");
	printf("\nInput COM-port (1-4):");
	gets(stringser);
	com= abs(atoi(stringser))-1;
	}
	printf ( "Port used: COM%d\n",com+1 );

/*setup serial i/o*/
serinit();

lcddrv("M:","Channel_Cntrl;",14); /* */
delay(500); /* */

/* get input data via commandline or via stdin */
if ( _argc >1 )
	{
	chan = atoi( _argv[1]);
	}
	else
	{
	printf("\nInput Channel (1 Digit 0....7 ):");
	gets(stringser);
	chan= abs(atoi(stringser));
	}
if ( (chan < 0) | (chan > 7) ) chan=0;
printf("Channel = %d\n", chan);

itoa(chan,stringser,10); /**/
lcddrv("Ch",stringser,1); /* */
delay(100); /* */
switch (chan) {
  case 0:   {
  lcddrv("M:","1707.0 MHz;",11); /* */
  printf("1707.0 MHz");
  }
  break;
  case 1:   {
  lcddrv("M:","1698.0 MHz;",11); /* */
  printf("1698.0 MHz");
  }
  break;
  case 2:   {
  lcddrv("M:","1700.4 MHz;",11); /* */
  printf("1700.4 MHz");
  }
  break;
  case 3:   {
  lcddrv("M:","1702.5 MHz;",11); /* */
  printf("1702.5 MHz");
  }
  break;
  case 4:   {
  lcddrv("M:","1694.5 MHz;",11); /* */
  printf("1694.5 MHz");
  }
  break;
  case 5:   {
  lcddrv("M:","1691.0 MHz;",11); /* */
  printf("1691.0 MHz");
  }
  break;
  case 6:   {
  lcddrv("M:","1707.0 MHz;",11); /* */
  printf("1707.0 MHz");
  }
  break;
  case 7:   {
  lcddrv("M:","1707.0 MHz;",11); /* */
  printf("1707.0 MHz");
  }
  break;
}
delay(500); /* */
}
